"use strict";var juju={components:{}};chai.config.includeStack=true;chai.config.truncateThreshold=0;describe("DeploymentBar",function(){var previousNotifications;beforeAll(function(done){YUI().use("deployment-bar",function(){done()})});beforeEach(function(){var DeploymentBar=juju.components.DeploymentBar;previousNotifications=DeploymentBar.prototype.previousNotifications;juju.components.DeploymentBar.prototype.previousNotifications=[]});afterEach(function(){var DeploymentBar=juju.components.DeploymentBar;DeploymentBar.prototype.previousNotifications=previousNotifications});it("can render and pass the correct props",function(){var currentChangeSet={one:1,two:2};var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.DeploymentBar,{changeState:sinon.stub(),currentChangeSet:currentChangeSet,exportEnvironmentFile:sinon.stub(),generateChangeDescription:sinon.stub(),hasEntities:true,hideDragOverNotification:sinon.stub(),importBundleFile:sinon.stub(),modelCommitted:false,renderDragOverNotification:sinon.stub(),showInstall:true}),true);var instance=renderer.getMountedInstance();var output=renderer.getRenderOutput();var expected=React.createElement(juju.components.Panel,{instanceName:"deployment-bar-panel",visible:true},React.createElement("div",{className:"deployment-bar"},React.createElement("span",{className:"deployment-bar__import link",onClick:instance._handleImportClick,role:"button",tabIndex:"0"},"Import"),React.createElement("span",{className:"deployment-bar__export link",onClick:instance._handleExport,role:"button",tabIndex:"0"},"Export"),React.createElement("a",{className:"button--inline-neutral",href:"https://jujucharms.com/get-started",target:"_blank"},"Install Juju"),React.createElement(juju.components.DeploymentBarNotification,{change:null}),React.createElement("div",{className:"deployment-bar__deploy"},React.createElement(juju.components.GenericButton,{action:instance._deployAction,type:"inline-deployment",disabled:false,title:"Deploy changes (2)"})),React.createElement("input",{className:"deployment-bar__file",type:"file",onChange:instance._handleImportFile,accept:".zip,.yaml,.yml",ref:"file-input"})));assert.deepEqual(output,expected)});it("sets the initial class if there are no changes or entites",function(){var currentChangeSet={};var deployButtonAction=sinon.stub();var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.DeploymentBar,{changeState:sinon.stub(),currentChangeSet:currentChangeSet,deployButtonAction:deployButtonAction,exportEnvironmentFile:sinon.stub(),generateChangeDescription:sinon.stub(),hasEntities:false,hideDragOverNotification:sinon.stub(),importBundleFile:sinon.stub(),modelCommitted:false,renderDragOverNotification:sinon.stub(),showInstall:true}),true);var output=renderer.getRenderOutput();var expected=React.createElement(juju.components.Panel,{instanceName:"deployment-bar-panel",visible:true},React.createElement("div",{className:"deployment-bar deployment-bar--initial"},output.props.children.props.children));assert.deepEqual(output,expected)});it("does not set the initial class if there are entites",function(){var currentChangeSet={};var deployButtonAction=sinon.stub();var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.DeploymentBar,{changeState:sinon.stub(),currentChangeSet:currentChangeSet,deployButtonAction:deployButtonAction,exportEnvironmentFile:sinon.stub(),generateChangeDescription:sinon.stub(),hasEntities:true,hideDragOverNotification:sinon.stub(),importBundleFile:sinon.stub(),modelCommitted:false,renderDragOverNotification:sinon.stub(),showInstall:true}),true);var output=renderer.getRenderOutput();var expected=React.createElement(juju.components.Panel,{instanceName:"deployment-bar-panel",visible:true},React.createElement("div",{className:"deployment-bar"},output.props.children.props.children));assert.deepEqual(output,expected)});it("does not set the initial class if there are changes",function(){var currentChangeSet={one:true};var deployButtonAction=sinon.stub();var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.DeploymentBar,{changeState:sinon.stub(),currentChangeSet:currentChangeSet,deployButtonAction:deployButtonAction,exportEnvironmentFile:sinon.stub(),generateChangeDescription:sinon.stub(),hasEntities:false,hideDragOverNotification:sinon.stub(),importBundleFile:sinon.stub(),modelCommitted:false,renderDragOverNotification:sinon.stub(),showInstall:true}),true);var output=renderer.getRenderOutput();var expected=React.createElement(juju.components.Panel,{instanceName:"deployment-bar-panel",visible:true},React.createElement("div",{className:"deployment-bar"},output.props.children.props.children));assert.deepEqual(output,expected)});it("can render without the install button",function(){var currentChangeSet={one:1,two:2};var deployButtonAction=sinon.stub();var output=jsTestUtils.shallowRender(React.createElement(juju.components.DeploymentBar,{changeState:sinon.stub(),currentChangeSet:currentChangeSet,deployButtonAction:deployButtonAction,exportEnvironmentFile:sinon.stub(),generateChangeDescription:sinon.stub(),hasEntities:false,hideDragOverNotification:sinon.stub(),importBundleFile:sinon.stub(),modelCommitted:false,renderDragOverNotification:sinon.stub(),showInstall:false}));assert.isUndefined(output.props.children.props.children[2])});it("enables the button if there are changes",function(){var currentChangeSet={one:1,two:2};var deployButtonAction=sinon.stub();var output=jsTestUtils.shallowRender(React.createElement(juju.components.DeploymentBar,{changeState:sinon.stub(),currentChangeSet:currentChangeSet,deployButtonAction:deployButtonAction,exportEnvironmentFile:sinon.stub(),generateChangeDescription:sinon.stub(),hasEntities:false,hideDragOverNotification:sinon.stub(),importBundleFile:sinon.stub(),modelCommitted:false,renderDragOverNotification:sinon.stub(),showInstall:true}));assert.isFalse(output.props.children.props.children[4].props.children.props.disabled)});it("can export the env",function(){var currentChangeSet={one:1,two:2};var deployButtonAction=sinon.stub();var exportEnvironmentFile=sinon.stub();var output=jsTestUtils.shallowRender(React.createElement(juju.components.DeploymentBar,{changeState:sinon.stub(),currentChangeSet:currentChangeSet,deployButtonAction:deployButtonAction,exportEnvironmentFile:exportEnvironmentFile,generateChangeDescription:sinon.stub(),hasEntities:false,hideDragOverNotification:sinon.stub(),importBundleFile:sinon.stub(),modelCommitted:false,renderDragOverNotification:sinon.stub(),showInstall:true}));output.props.children.props.children[1].props.onClick();assert.equal(exportEnvironmentFile.callCount,1)});it("can open the file dialog when import is clicked",function(){var currentChangeSet={one:1,two:2};var fileClick=sinon.stub();var importBundleFile=sinon.stub();var generateChangeDescription=sinon.stub();var hideDragOverNotification=sinon.stub();var renderDragOverNotification=sinon.stub();var exportEnvironmentFile=sinon.stub();var deployButtonAction=sinon.stub();var shallowRenderer=jsTestUtils.shallowRender(React.createElement(juju.components.DeploymentBar,{changeState:sinon.stub(),deployButtonAction:deployButtonAction,exportEnvironmentFile:exportEnvironmentFile,renderDragOverNotification:renderDragOverNotification,hasEntities:false,importBundleFile:importBundleFile,hideDragOverNotification:hideDragOverNotification,generateChangeDescription:generateChangeDescription,currentChangeSet:currentChangeSet,modelCommitted:false,showInstall:true}),true);var instance=shallowRenderer.getMountedInstance();instance.refs={"file-input":{click:fileClick}};var output=shallowRenderer.getRenderOutput();output.props.children.props.children[0].props.onClick();assert.equal(fileClick.callCount,1)});it("can get a file when a file is selected",function(){var currentChangeSet={one:1,two:2};var importBundleFile=sinon.stub();var generateChangeDescription=sinon.stub();var hideDragOverNotification=sinon.stub();var renderDragOverNotification=sinon.stub();var exportEnvironmentFile=sinon.stub();var deployButtonAction=sinon.stub();var shallowRenderer=jsTestUtils.shallowRender(React.createElement(juju.components.DeploymentBar,{changeState:sinon.stub(),deployButtonAction:deployButtonAction,exportEnvironmentFile:exportEnvironmentFile,renderDragOverNotification:renderDragOverNotification,importBundleFile:importBundleFile,hasEntities:false,hideDragOverNotification:hideDragOverNotification,generateChangeDescription:generateChangeDescription,currentChangeSet:currentChangeSet,modelCommitted:false,showInstall:true}),true);var instance=shallowRenderer.getMountedInstance();instance.refs={"file-input":{files:["apache2.yaml"]}};var output=shallowRenderer.getRenderOutput();output.props.children.props.children[5].props.onChange();assert.equal(importBundleFile.callCount,1);assert.equal(importBundleFile.args[0][0],"apache2.yaml")});it("disables the button if there are no changes",function(){var currentChangeSet={};var deployButtonAction=sinon.stub();var output=jsTestUtils.shallowRender(React.createElement(juju.components.DeploymentBar,{changeState:sinon.stub(),currentChangeSet:currentChangeSet,deployButtonAction:deployButtonAction,exportEnvironmentFile:sinon.stub(),generateChangeDescription:sinon.stub(),hasEntities:false,hideDragOverNotification:sinon.stub(),importBundleFile:sinon.stub(),modelCommitted:false,renderDragOverNotification:sinon.stub(),showInstall:true}));assert.isTrue(output.props.children.props.children[4].props.children.props.disabled)});it("passes the button the correct title if there are commits",function(){var currentChangeSet={};var deployButtonAction=sinon.stub();var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.DeploymentBar,{changeState:sinon.stub(),currentChangeSet:currentChangeSet,hasEntities:false,deployButtonAction:deployButtonAction,exportEnvironmentFile:sinon.stub(),generateChangeDescription:sinon.stub(),hideDragOverNotification:sinon.stub(),importBundleFile:sinon.stub(),modelCommitted:true,renderDragOverNotification:sinon.stub(),showInstall:true}),true);var output=renderer.getRenderOutput();assert.equal(output.props.children.props.children[4].props.children.props.title,"Commit changes (0)")});it("can display a notification",function(){var change={change:"add-services-1"};var currentChangeSet={"add-services-1":"add-services-change"};var deployButtonAction=sinon.stub();var generateChangeDescription=sinon.stub().returns(change);var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.DeploymentBar,{changeState:sinon.stub(),currentChangeSet:currentChangeSet,exportEnvironmentFile:sinon.stub(),generateChangeDescription:generateChangeDescription,hasEntities:false,hideDragOverNotification:sinon.stub(),deployButtonAction:deployButtonAction,importBundleFile:sinon.stub(),modelCommitted:false,renderDragOverNotification:sinon.stub(),showInstall:true}),true);var output=renderer.getRenderOutput();renderer.render(React.createElement(juju.components.DeploymentBar,{changeState:sinon.stub(),currentChangeSet:currentChangeSet,exportEnvironmentFile:sinon.stub(),generateChangeDescription:generateChangeDescription,hasEntities:false,deployButtonAction:deployButtonAction,hideDragOverNotification:sinon.stub(),importBundleFile:sinon.stub(),modelCommitted:false,renderDragOverNotification:sinon.stub(),showInstall:true}));output=renderer.getRenderOutput();assert.deepEqual(output.props.children.props.children[3],React.createElement(juju.components.DeploymentBarNotification,{change:change}));assert.equal(generateChangeDescription.args[0][0],"add-services-change")});it("can display a new notification",function(){var change={change:"add-services-1"};var currentChangeSet={"add-services-1":"add-services-change"};var deployButtonAction=sinon.stub();var generateChangeDescription=sinon.stub().returns(change);var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.DeploymentBar,{changeState:sinon.stub(),currentChangeSet:currentChangeSet,exportEnvironmentFile:sinon.stub(),generateChangeDescription:generateChangeDescription,hasEntities:false,hideDragOverNotification:sinon.stub(),deployButtonAction:deployButtonAction,importBundleFile:sinon.stub(),modelCommitted:false,renderDragOverNotification:sinon.stub(),showInstall:true}),true);var output=renderer.getRenderOutput();renderer.render(React.createElement(juju.components.DeploymentBar,{changeState:sinon.stub(),currentChangeSet:currentChangeSet,exportEnvironmentFile:sinon.stub(),generateChangeDescription:generateChangeDescription,hasEntities:false,hideDragOverNotification:sinon.stub(),deployButtonAction:deployButtonAction,importBundleFile:sinon.stub(),modelCommitted:false,renderDragOverNotification:sinon.stub(),showInstall:true}));output=renderer.getRenderOutput();assert.deepEqual(output.props.children.props.children[3],React.createElement(juju.components.DeploymentBarNotification,{change:change}));change={change:"added-unit-1"};currentChangeSet["added-unit-1"]="added-unit-change";generateChangeDescription.returns(change);renderer.render(React.createElement(juju.components.DeploymentBar,{changeState:sinon.stub(),currentChangeSet:currentChangeSet,exportEnvironmentFile:sinon.stub(),generateChangeDescription:generateChangeDescription,hasEntities:false,hideDragOverNotification:sinon.stub(),importBundleFile:sinon.stub(),deployButtonAction:deployButtonAction,modelCommitted:false,renderDragOverNotification:sinon.stub(),showInstall:true}));output=renderer.getRenderOutput();assert.deepEqual(output.props.children.props.children[3],React.createElement(juju.components.DeploymentBarNotification,{change:change}))});it("does not display a previously displayed notification",function(){var change={change:"add-services-1"};var currentChangeSet={"add-services-1":"add-services-change"};var deployButtonAction=sinon.stub();var generateChangeDescription=sinon.stub().returns(change);var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.DeploymentBar,{changeState:sinon.stub(),currentChangeSet:currentChangeSet,exportEnvironmentFile:sinon.stub(),generateChangeDescription:generateChangeDescription,hasEntities:false,hideDragOverNotification:sinon.stub(),importBundleFile:sinon.stub(),deployButtonAction:deployButtonAction,modelCommitted:false,renderDragOverNotification:sinon.stub(),showInstall:true}),true);var output=renderer.getRenderOutput();renderer.render(React.createElement(juju.components.DeploymentBar,{changeState:sinon.stub(),currentChangeSet:currentChangeSet,exportEnvironmentFile:sinon.stub(),generateChangeDescription:generateChangeDescription,hasEntities:false,hideDragOverNotification:sinon.stub(),importBundleFile:sinon.stub(),deployButtonAction:deployButtonAction,modelCommitted:false,renderDragOverNotification:sinon.stub(),showInstall:true}));output=renderer.getRenderOutput();assert.deepEqual(output.props.children.props.children[3],React.createElement(juju.components.DeploymentBarNotification,{change:change}));change={change:"added-unit-1"};currentChangeSet["added-unit-1"]="added-unit-change";generateChangeDescription.returns(change);renderer.render(React.createElement(juju.components.DeploymentBar,{changeState:sinon.stub(),currentChangeSet:currentChangeSet,exportEnvironmentFile:sinon.stub(),generateChangeDescription:generateChangeDescription,hasEntities:false,hideDragOverNotification:sinon.stub(),deployButtonAction:deployButtonAction,importBundleFile:sinon.stub(),modelCommitted:false,renderDragOverNotification:sinon.stub(),showInstall:true}));output=renderer.getRenderOutput();assert.deepEqual(output.props.children.props.children[3],React.createElement(juju.components.DeploymentBarNotification,{change:change}));delete currentChangeSet["added-unit-1"];generateChangeDescription.returns("add-services-change");renderer.render(React.createElement(juju.components.DeploymentBar,{changeState:sinon.stub(),currentChangeSet:currentChangeSet,exportEnvironmentFile:sinon.stub(),generateChangeDescription:generateChangeDescription,hasEntities:false,hideDragOverNotification:sinon.stub(),importBundleFile:sinon.stub(),deployButtonAction:deployButtonAction,modelCommitted:false,renderDragOverNotification:sinon.stub(),services:[],showInstall:true}));output=renderer.getRenderOutput();assert.deepEqual(output.props.children.props.children[3],React.createElement(juju.components.DeploymentBarNotification,{change:change}))})});